#ifndef _GAMEGLOBAL_H_
#define _GAMEGLOBAL_H_

//Header file which gives a game global variable list one can use to compile with. 

#include <header.h>
#include <level.h>
#include <global.h>
#include <smokeparticle.h>
#include <newsparticle.h>
#include <fireparticle.h>
#include <boomparticle.h>
#include <trashparticle.h>
#include <math.h>

#define DISTANCE 140
#define XDIFF 200
#define YDIFF 400
#define ZDIFF 40
#define GRAVITY  1
#define ADJUST_FACTOR (-1.f/3.4f)

extern int nlevels;
extern int curlevel;
extern level **levels;

extern BITMAP *bg, *factory, *fire[FIRE_SIZES], *smoke[SMOKE_SIZES], *ftgun, *newspaperroll, *newspaper1, *newspaper2, *boom;
extern FONT *bigfont,*normalfont;

extern particle smokeparticles[SMOKE_PARTICLES];
extern particle fireparticles[FIRE_PARTICLES];
extern particle newsparticles[NEWS_PARTICLES];
extern particle boomparticles[BOOM_PARTICLES];
extern particle trashparticles[TRASH_PARTICLES];

extern int facx,facy;
extern int ftgunx,ftguny,ftgunax,ftgunang,ftgunvang;
extern int newsx[NEWS_SLOTS],newsy[NEWS_SLOTS];
extern int smokex[SMOKE_SLOTS],smokey[SMOKE_SLOTS];

#endif //_GAMEGLOBAL_H_
