#ifndef _GAMESTATE_H_
#define _GAMESTATE_H_

//Header file for Game States.

#include <header.h>
#include <game.h>

#define GAME_USUAL -1	
#define GAME_PLAY 0
#define GAME_LOSE 1
#define GAME_WIN  2
#define GAME_SPLASH 3

extern int oldstate;
extern int state;

//During GamePlay
int game_play_init();
void game_play_logic();
void game_play_input();
void game_play_render();
void game_play_quit();

//For Game Lose
int game_lose_init();
void game_lose_logic();
void game_lose_input();
void game_lose_render();
void game_lose_quit();

//For Game Win
int game_win_init();
void game_win_logic();
void game_win_input();
void game_win_render();
void game_win_quit();

//For Game Splash
int game_splash_init();
void game_splash_logic();
void game_splash_input();
void game_splash_render();
void game_splash_quit();

//Usual Unimplemented
int usual_init();
void usual_logic();
void usual_input();
void usual_render();
void usual_quit();

//Init for States
int state_init();

//Logic for States
void state_logic();

//Input for States
void state_input();

//Render for States
void state_render();

//Switch to State
void state_switch(int newstate);

//Quit for States
void state_quit();

//Quit for States
void terminate_state_loop();

#endif //_GAMESTATE_H_
