#ifndef _PARTICLE_H_
#define	_PARTICLE_H_

#define PLIST_END -1

#define P_DEAD 0
#define P_ALIVE 1

#define P_EVICT 0
#define P_REMAIN 1

#define PARTICLESPACE 256

//Header File Containing Generic Particle Routines.

typedef struct{
    int status; //P_DEAD or P_ALIVE
    char buff[PARTICLESPACE];
}particle;

typedef int (*update_function)(particle *, int, int); //Returns P_EVICT or P_REMAIN
typedef int (*compare_function)(particle *, particle *); //Returns 1,0 or -1

void initparticles(particle *, int);
void sortparticles(particle *, int, compare_function);
int spawnparticle(particle *, int, void *, int);
void evictparticle(particle *, int, int);
void updateparticles(particle *, int, update_function);

#endif	// _PARTICLE_H_

