#include <boomparticle.h>
#include <gameglobal.h>

static int boomsortparticle(particle *p1, particle *p2){
    int status=0;
    if(p1->status==P_DEAD) {
        if(p2->status==P_ALIVE) status=-1;
    } else {
        if(p2->status==P_DEAD) status=1;
        else {
            boomparticleinfo *ptr1=(boomparticleinfo *)p1->buff;
            boomparticleinfo *ptr2=(boomparticleinfo *)p2->buff;
            if(ptr2->z>ptr1->z) status=1; 
            else if(ptr2->z<ptr1->z) status=-1;
        }
    }
   return status;
}

static int boomdrawparticle(particle *plist, int listsize, int index){
    boomparticleinfo *ptr=(boomparticleinfo *)plist[index].buff;
    float scale=(float)ptr->size*DISTANCE/(ptr->z+(DISTANCE<<2));
    rotate_scaled_sprite(dbuffer,boom,ptr->x+(int)((boom->w>>1)*scale),ptr->y-(int)((boom->h>>1)*scale),itofix(-64),ftofix(scale));
    return P_REMAIN;
}

static int boomupdateparticle(particle *plist, int listsize, int index){
    int w,h;
    float scale;
    int status=P_REMAIN;
    boomparticleinfo *ptr=(boomparticleinfo *)plist[index].buff;
    scale=(float)ptr->size*DISTANCE/(ptr->z+(DISTANCE<<2));
    ptr->timer++;
    ptr->size++;
    w=(int)(boom->w*ptr->size*scale); h=(int)(boom->h*ptr->size*scale);
    if(ptr->timer>BOOM_LIFETIME) {
            status=P_EVICT; 
    }
    if((ptr->x+(w>>1))<=0||(ptr->y+(h>>1))<=0) status=P_EVICT;
    if(ptr->x>=(xres+(w>>1))||ptr->y>=(yres+(h>>1))) status=P_EVICT;
    return status;
}

void boominit(){
    initparticles(boomparticles, BOOM_PARTICLES);
}


void boomdraw(){
    updateparticles(boomparticles, BOOM_PARTICLES, boomdrawparticle);
}

void boomspawn(int x, int y, int z){
    boomparticleinfo newboom;
    newboom.x=x; newboom.y=y; newboom.z=z; newboom.timer=0;
    newboom.size=1;
    spawnparticle(boomparticles, BOOM_PARTICLES, &newboom, sizeof(boomparticleinfo));
}

void boomsort(){
    sortparticles(boomparticles, BOOM_PARTICLES, boomsortparticle);
}

void boomupdate(){
    updateparticles(boomparticles, BOOM_PARTICLES, boomupdateparticle);
}
