//Source file for logging functions.

#include <log.h>
#include <util.h>

//Log Stream Object
FILE *logstr=NULL;

//Output a newline
int log_newline(){
	int status=0;

	status+=fprintf(logstr, "\n");

	fflush(logstr);

	return status;
}

//printf like function to write to log
int log_printf(char *format, ...){
	int status=0;
	time_t logtime;
	va_list ap;

	time(&logtime);

	//Write timestamp
	status+=fprintf(logstr, "[%s]: ", strip_crlfs(ctime(&logtime)));
	//Write actual message
	va_start(ap,format);
	status+=vfprintf(logstr, format, ap);
	va_end(ap);	
	//Write New Line
	status+=log_newline();

	fflush(logstr);

	return status;
}

//Closes logging system. 
void quit_log(){
	if(logstr) {
		//Close Log Stream
		fflush(logstr);
		if(logstr!=stdout&&logstr!=stderr) fclose(logstr);
		logstr=NULL;
	}	
}

//Initializes logging system. 
int init_log(){

	quit_log();
	//Open Log Stream
	if(!strcmp("stdout",LOGFILE)) logstr=stdout;
	else if(!strcmp("stderrt",LOGFILE)) logstr=stderr;
	else logstr=fopen(LOGFILE,"a+t"); 
	if(!logstr) logstr=stdout;

	//Write Log Message
	log_newline();
	log_printf("-------------------------------------------------------");
	log_printf("Log Initialized");

	return 0;
}
