#include <newsparticle.h>
#include <trashparticle.h>
#include <game.h>
#include <gameglobal.h>

static int newssortparticle(particle *p1, particle *p2){
    int status=0;
    if(p1->status==P_DEAD) {
        if(p2->status==P_ALIVE) status=-1;
    } else {
        if(p2->status==P_DEAD) status=1;
        else {
            newsparticleinfo *ptr1=(newsparticleinfo *)p1->buff;
            newsparticleinfo *ptr2=(newsparticleinfo *)p2->buff;
            if(ptr2->z>ptr1->z) status=1; 
            else if(ptr2->z<ptr1->z) status=-1;
        }
    }
   return status;
}

static int newsdrawparticle(particle *plist, int listsize, int index){
    newsparticleinfo *ptr=(newsparticleinfo *)plist[index].buff;
    float scale=(float)DISTANCE/(ptr->z+(DISTANCE<<2));    
    rotate_scaled_sprite(dbuffer,newspaperroll,ptr->x+(int)((newspaperroll->w>>1)*scale),ptr->y-(int)((newspaperroll->h>>1)*scale),itofix(ptr->angle),ftofix(scale));
    return P_REMAIN;
}

static int newsupdateparticle(particle *plist, int listsize, int index){
    int w,h;
    int status=P_REMAIN;
    float scale;
    newsparticleinfo *ptr=(newsparticleinfo *)plist[index].buff;
    ptr->x+=ptr->vx;    ptr->y+=ptr->vy;   ptr->z+=ptr->vz;
    ptr->vx+=ptr->ax;  ptr->vy+=ptr->ay;   ptr->vz+=ptr->az;
    if(ptr->vy<0) ;
    else if(ptr->vy==0) {
        ptr->dir=NEWS_PARTDOWN;
    } else if(ptr->vy>=ptr->finy) {
            status=P_EVICT; 
            trashspawn(ptr->x+4-rand()%9,ptr->y,ptr->z+rand()%3,ptr->angle+rand()%16);
            levels[curlevel]->misses++;
    }
    scale=(float)DISTANCE/(ptr->z+(DISTANCE<<2));
    w=(int)(newspaperroll->w*scale); h=(int)(newspaperroll->h*scale);
    ptr->timer++;
    ptr->angle+=5;
    if(ptr->timer>NEWS_LIFETIME) {
            status=P_EVICT; 
    }
    if((ptr->x+(w>>1))<=0||(ptr->y+(h>>1))<=0) status=P_EVICT;
    if(ptr->x>=(xres+(w>>1))||ptr->y>=(yres+(h>>1))) status=P_EVICT;
    return status;
}

void newsinit(){
    initparticles(newsparticles, NEWS_PARTICLES);
}

void newsdraw(){
    updateparticles(newsparticles, NEWS_PARTICLES, newsdrawparticle);
}

void newsspawn(){
    int index=rand()%NEWS_SLOTS;
    newsparticleinfo newnews;
    newnews.ax=0;   newnews.ay=GRAVITY;   newnews.az=0;
    newnews.z=DISTANCE<<2; newnews.x=facx+newsx[index]; newnews.y=facy+newsy[index];
    if((index%3)==0)
        newnews.vx=-4-rand()%5;
    else if((index%3)==1)
        newnews.vx=3-rand()%7;
    else
        newnews.vx=4+rand()%5;
    newnews.vy=-7-rand()%4;
    newnews.vz=-2;
    newnews.angle=(game_timer%8)<<5;
    newnews.finy=-newnews.vy+(int)sqrtf(((factory->h-newsy[index])*newnews.ay)*2.f);
    newnews.dir=NEWS_PARTUP;
    newnews.timer=0;
    spawnparticle(newsparticles, NEWS_PARTICLES, &newnews, sizeof(newsparticleinfo));
}

void newssort(){
    sortparticles(newsparticles, NEWS_PARTICLES, newssortparticle);
}

void newsupdate(){
    updateparticles(newsparticles, NEWS_PARTICLES, newsupdateparticle);
}
