//Source file for One Time Data Loading/Unloading.

#include <log.h>
#include <onetime.h>
#include <gameglobal.h>

//Unload Data One Time
void unload_data_onetime(){
    int i;
    log_printf("Unloading Sprites");
    if(bg) destroy_bitmap(bg); bg=NULL;
    if(factory) destroy_bitmap(factory); factory=NULL;
    if(ftgun) destroy_bitmap(ftgun); ftgun=NULL;
    if(newspaper2) destroy_bitmap(newspaper2); newspaper2=NULL;
    if(newspaper1) destroy_bitmap(newspaper1); newspaper1=NULL;
    if(newspaperroll) destroy_bitmap(newspaperroll); newspaperroll=NULL;
    if(boom) destroy_bitmap(boom); boom=NULL;
    for(i=0;i<FIRE_SIZES;++i){
        if(fire[i]) destroy_bitmap(fire[i]);
        fire[i]=NULL;
    }
    for(i=0;i<SMOKE_SIZES;++i){
        if(smoke[i]) destroy_bitmap(smoke[i]);
        smoke[i]=NULL;
    }    
    if(bigfont) destroy_font(bigfont); bigfont=NULL;
    if(normalfont) destroy_font(normalfont); normalfont=NULL;
    log_printf("Unloaded Sprites");
}

//Load Data One Time
int load_data_onetime(){
        int i;
        char filename[MAXSTR];
        
        log_printf("Loading Sprites");

	sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"BG.bmp");
        if(!(bg=load_bitmap(filename,NULL))) return -1;
                
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"Factory.bmp");
        if(!(factory=load_bitmap(filename,NULL))) return -1;
        facx=(xres-factory->w)>>1;
        facy=(yres-factory->h)>>1;
        
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"FTGun.bmp");
        if(!(ftgun=load_bitmap(filename,NULL))) return -1;
        ftgunax=ftgunx=(xres-ftgun->w)>>1; //Gun is Horizontal.
        ftguny=yres-(ftgun->w>>1)+ftgun->h+(ftgun->h>>1);
        ftgunang=64;
        ftgunvang=32;
        
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"Boom.bmp");
        if(!(boom=load_bitmap(filename,NULL))) return -1;
        
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"NewsPaperRoll.bmp");
        if(!(newspaperroll=load_bitmap(filename,NULL))) return -1;

        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"NewsPaper1.bmp");
        if(!(newspaper1=load_bitmap(filename,NULL))) return -1;
                
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,"NewsPaper2.bmp");
        if(!(newspaper2=load_bitmap(filename,NULL))) return -1;
        
        for(i=0;i<FIRE_SIZES;++i){
            sprintf(filename,"%s%c%s%c%s%d%s","Data",PATHSEP,"Sprites",PATHSEP,"Fire",i+1,".bmp");
            if(!(fire[i]=load_bitmap(filename,NULL))) return -1;
        }
        
        for(i=0;i<SMOKE_SIZES;++i){
            sprintf(filename,"%s%c%s%c%s%d%s","Data",PATHSEP,"Sprites",PATHSEP,"Smoke",i+1,".bmp");
            if(!(smoke[i]=load_bitmap(filename,NULL))) return -1;
        }
        
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Fonts",PATHSEP,"Title.bmp");
        if(!(bigfont=load_font(filename,NULL,NULL))) return -1;
        
        sprintf(filename,"%s%c%s%c%s","Data",PATHSEP,"Fonts",PATHSEP,"Normal.bmp");
        if(!(normalfont=load_font(filename,NULL,NULL))) return -1;
        
	return 0;
}

