#include <particle.h>
#include <log.h>

void initparticles(particle *plist, int listsize){
    int i;
    
    //if(listsize<=0) return;
    //if(!plist) return;
    
    log_printf("Initializing %d Particles",listsize);
    
    for(i=0;i<listsize-1;++i) {
        plist[i].status=P_DEAD;
    }
    plist[i].status=P_DEAD;
    
    log_printf("Initialized Particles");
}

void sortparticles(particle *plist, int listsize, compare_function compare){
    //if(listsize<=0) return -1;
    //if(!plist) return -1;
    //if(!compare) return;
    qsort(plist,listsize,sizeof(particle),(int (*)(const void*, const void*))compare);
}

int spawnparticle(particle *plist, int listsize, void *buff, int size){
    int deadindex=0;
    //if(listsize<=0) return -1;
    //if(!plist) return -1;
    for(;deadindex<listsize&&plist[deadindex].status!=P_DEAD;++deadindex);
    if(deadindex==listsize) return -1;
    plist[deadindex].status=P_ALIVE;
    memcpy(plist[deadindex].buff,buff,size);
    return deadindex;
}

void evictparticle(particle *plist, int listsize, int index){
    //if(listsize<=0) return;
    //if(!plist) return;
    //if(index<0||index>=listsize) return;
    plist[index].status=P_DEAD;
}

void updateparticles(particle *plist, int listsize, update_function update){
    int aliveindex=0,status;
    //if(listsize<=0) return;
    //if(!plist) return;
    //if(!update) return;
    for(;aliveindex<listsize&&plist[aliveindex].status!=P_ALIVE;++aliveindex);
    if(aliveindex==listsize) return;
    if(plist[aliveindex].status==P_ALIVE) 
          if(update(plist, listsize, aliveindex)==P_EVICT)
              evictparticle(plist,listsize,aliveindex);
    ++aliveindex;
    while(aliveindex<listsize){
        if(plist[aliveindex].status==P_ALIVE) 
            if(update(plist, listsize, aliveindex)==P_EVICT)
               evictparticle(plist,listsize,aliveindex);
        ++aliveindex;
    }
}
