#include <smokeparticle.h>
#include <gameglobal.h>

static int smokedrawparticle(particle *plist, int listsize, int index){
    smokeparticleinfo *ptr=(smokeparticleinfo *)plist[index].buff;
    draw_sprite(dbuffer,smoke[ptr->size],ptr->x-(smoke[ptr->size]->w>>1),ptr->y-(smoke[ptr->size]->h>>1));
    return P_REMAIN;
}

static int smokeupdateparticle(particle *plist, int listsize, int index){
    int w,h;
    int status=P_REMAIN;
    smokeparticleinfo *ptr=(smokeparticleinfo *)plist[index].buff;
    ptr->x+=ptr->vx;    ptr->y+=ptr->vy;
    ptr->vx+=ptr->ax;    ptr->vy+=ptr->ay;
    w=smoke[ptr->size]->w; h=smoke[ptr->size]->h;
    ptr->timer++;
    if(ptr->size<(SMOKE_SIZES-1)) {
        if(ptr->timer>SMOKE_LIFETIME) { 
            ptr->size++; 
            ptr->timer=0;
        }
    } else if(ptr->timer>SMOKE_MAXLIFETIME) {
            status=P_EVICT; 
    }
    if((ptr->x+(w>>1))<=0||(ptr->y+(h>>1))<=0) status=P_EVICT;
    if(ptr->x>=(xres+(w>>1))||ptr->y>=(yres+(h>>1))) status=P_EVICT;
    return status;
}

void smokeinit(){
    initparticles(smokeparticles, SMOKE_PARTICLES);
}

void smokedraw(){
    updateparticles(smokeparticles, SMOKE_PARTICLES, smokedrawparticle);
}

void smokespawn(){
    int index=rand()%SMOKE_SLOTS;
    smokeparticleinfo newsmoke;
    newsmoke.ax=0;   newsmoke.ay=0;
    newsmoke.vx=-4;   newsmoke.vy=-8;
    newsmoke.x=facx+smokex[index]; newsmoke.y=facy+smokey[index];
    newsmoke.size=0;
    newsmoke.timer=0;
    spawnparticle(smokeparticles, SMOKE_PARTICLES, &newsmoke, sizeof(smokeparticleinfo));
}

void smokeupdate(){
    updateparticles(smokeparticles, SMOKE_PARTICLES, smokeupdateparticle);
}
