#include <trashparticle.h>
#include <gameglobal.h>

static int trashsortparticle(particle *p1, particle *p2){
    int status=0;
    if(p1->status==P_DEAD) {
        if(p2->status==P_ALIVE) status=-1;
    } else {
        if(p2->status==P_DEAD) status=1;
        else {
            trashparticleinfo *ptr1=(trashparticleinfo *)p1->buff;
            trashparticleinfo *ptr2=(trashparticleinfo *)p2->buff;
            if(ptr2->z>ptr1->z) status=1; 
            else if(ptr2->z<ptr1->z) status=-1;
        }
    }
   return status;
}

static int trashdrawparticle(particle *plist, int listsize, int index){
    trashparticleinfo *ptr=(trashparticleinfo *)plist[index].buff;
    float scale=(float)DISTANCE/(ptr->z+(DISTANCE<<2));
    rotate_scaled_sprite(dbuffer,newspaperroll,ptr->x+(int)((newspaperroll->w>>1)*scale),ptr->y-(int)((newspaperroll->h>>1)*scale),itofix(ptr->angle),ftofix(scale));
    return P_REMAIN;
}

static int trashupdateparticle(particle *plist, int listsize, int index){
    int w,h;
    float scale;
    int status=P_REMAIN;
    trashparticleinfo *ptr=(trashparticleinfo *)plist[index].buff;
    scale=(float)DISTANCE/(ptr->z+(DISTANCE<<2));
    ptr->timer++;
    w=(int)(newspaperroll->w*scale); h=(int)(newspaperroll->h*scale);
    if(ptr->timer>TRASH_LIFETIME) {
            status=P_EVICT; 
    }
    if((ptr->x+(w>>1))<=0||(ptr->y+(h>>1))<=0) status=P_EVICT;
    if(ptr->x>=(xres+(w>>1))||ptr->y>=(yres+(h>>1))) status=P_EVICT;
    return status;
}

void trashinit(){
    initparticles(trashparticles, TRASH_PARTICLES);
}


void trashdraw(){
    updateparticles(trashparticles, TRASH_PARTICLES, trashdrawparticle);
}

void trashspawn(int x, int y, int z, int angle){
    trashparticleinfo newtrash;
    newtrash.x=x; newtrash.y=y; newtrash.z=z; newtrash.angle=angle; newtrash.timer=0;
    spawnparticle(trashparticles, TRASH_PARTICLES, &newtrash, sizeof(trashparticleinfo));
}

void trashsort(){
    sortparticles(trashparticles, TRASH_PARTICLES, trashsortparticle);
}

void trashupdate(){
    updateparticles(trashparticles, TRASH_PARTICLES, trashupdateparticle);
}
